/*-----------------------------------------------------------------------------
	Paper Plane xUI Common Control eXtension Module				(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include "ppx.h"
#include "vfs.h"
#include "PPX_DRAW.h"
#include "ppxccx.h"

WCHAR KeyWord[CMDLINESIZE] = L"";
size_t KeyWordLen = 0;
BOOL FirstKeyWord = FALSE;

UINT WM_PPXCOMMAND = 0;
int compinit = 0;
int UseDirectWrite = 0;
int X_ffix = 0;

HINSTANCE hInst;
const WCHAR NilStr[] = L"";

int TipX(PPXAPPINFOW *ppxa, PPXMCOMMANDSTRUCT *command);
int InitExtComplist(PPXAPPINFOW *ppxa, PPXMEXTLISTBOX *els);
int SetListKeyword(PPXAPPINFOW *ppxa, PPXMCOMMANDSTRUCT *command);

COLORREF C_tip[2] = {C_AUTO, C_AUTO};
C_WIN_COLORS wincolors = {
	C_AUTO, C_AUTO, C_AUTO, C_AUTO,
	C_AUTO, C_AUTO, C_AUTO, C_AUTO,
	C_AUTO, C_AUTO, C_AUTO, C_AUTO
};

#define C_KEYWORD_TEXT 0x60c0c0;
#define C_COMMENT_TEXT 0x0080FF;

COLORREF C_keyword = C_KEYWORD_TEXT;

#define C_WindowBack wincolors.WindowBack
#define C_WindowText wincolors.WindowText
#define C_HighlightBack wincolors.HighlightBack
#define C_HighlightText wincolors.HighlightText
#define C_EdgeLine wincolors.EdgeLine

#define C_DialogBack (wincolors.DialogBack) // _CAO\(3dFace)
#define C_FocusBack (wincolors.FocusBack)
#define C_DialogText (wincolors.DialogText) // _CAO

ValueWinAPI(GetColor) = NULL;
ValueWinAPI(GetCustData);
ValueWinAPI(GetCustTable);
ValueWinAPI(GetNumber);
ValueWinAPI(GetQuotedParameter);
ValueWinAPI(NextParameter);
ValueWinAPI(SkipSpace);
ValueWinAPI(SetCustTable);
ValueWinAPI(PPxCommonExtCommand);

// listbox gp
typedef struct {
	DXDRAWSTRUCT *DxDraw;
	WNDPROC ListProc; // XgRg[̃EBhEv[W
	HFONT hBoxFont;
	HWND ListWnd;
	HWND MsgWnd;
	HWND ParentWnd;
	int ItemHeight;
	int ItemLineSpace;
	int ItemTopMargin;
	int type;
	UINT ListID;
	int fontY;
	WCHAR TypeWord[CMDLINESIZE];
	size_t TypeWordLen;
} ExtCompStruct;

#define CompMsgClass L"CompMsgClass"
const WCHAR StrExtComplistProperty[] = L"PxmExtList";

COLORREF C_CommentBack;
COLORREF C_CommentText;
ATOM CompMsgAtom = 0;

#define DEFWINCOLOR(Color, Type) if ( Color == C_AUTO ) Color = GetSysColor(Type);

// tip \p
int X_uxt[2] = {X_uxt_defvalue};
const WCHAR FileTipClass[] = L"XTip";

/*-----------------------------------------------------------------------------
	dll ̏^I
-----------------------------------------------------------------------------*/
#pragma argsused
BOOL WINAPI DllEntry(HINSTANCE hInstance, DWORD reason, LPVOID reserved)
{
	if ( reason == DLL_PROCESS_ATTACH ){
		hInst = hInstance;
	}
	return TRUE;
}

/*-----------------------------------------------------------------------------
	{
-----------------------------------------------------------------------------*/
#pragma argsused
int PPXAPI ModuleEntry(PPXAPPINFOW *ppxa, DWORD cmdID, PPXMODULEPARAM pxs)
{
	if ( cmdID == PPXMEVENT_COMMAND ){
		if ( (pxs.command->commandhash == 0x81549458) && !wcscmp(pxs.command->commandname, L"TIPX") ){
			return TipX(ppxa, pxs.command);
		}
		if ( (pxs.command->commandhash == 0xdb5ff4f5) && !wcscmp(pxs.command->commandname, L"LISTKEYWORD") ){
			return SetListKeyword(ppxa, pxs.command);
		}
	} else if ( cmdID == PPXMEVENT_EXLISTBOX ){
		return InitExtComplist(ppxa, pxs.listbox);
	} else if ( cmdID == PPXMEVENT_CUSTOMIZE ){
		compinit = 0;
		return PPXMRESULT_SKIP;
	} else if ( cmdID == PPXM_INFORMATION ){
		if ( pxs.info->infotype == 0 ){
			pxs.info->typeflags = PPMTYPEFLAGS(PPXM_INFORMATION) |
				PPMTYPEFLAGS(PPXMEVENT_COMMAND) |
				PPMTYPEFLAGS(PPXMEVENT_EXLISTBOX) |
				PPMTYPEFLAGS(PPXMEVENT_CUSTOMIZE);
			wcscpy(pxs.info->copyright, L"PPx CCX Module " RELEASEVERSION L"  Copyright (c)TORO");
			return PPXMRESULT_DONE;
		}
	}
	return PPXMRESULT_SKIP;
}

void InitAPI(PPXAPPINFOW *ppxa)
{
	HMODULE hPPlib = (HMODULE)PPxInfoFunc(ppxa, PPXCMDID_PPLIBHANDLE, NULL);

	GETDLLPROC(hPPlib, GetColor);
	GETDLLPROC(hPPlib, GetCustData);
	GETDLLPROC(hPPlib, GetCustTable);
	GETDLLPROC(hPPlib, GetNumber);
	GETDLLPROC(hPPlib, GetQuotedParameter);
	GETDLLPROC(hPPlib, NextParameter);
	GETDLLPROC(hPPlib, SkipSpace);
	GETDLLPROC(hPPlib, SetCustTable);
	GETDLLPROC(hPPlib, PPxCommonExtCommand);

	WM_PPXCOMMAND = RegisterWindowMessage(T(PPXCOMMAND_WM));
}

TCHAR *tstristr(const TCHAR *target, const TCHAR *findstr, size_t len)
{
	size_t flen;
	const TCHAR *p, *maxptr;

	flen = tstrlen(findstr);
	maxptr = target + len - flen;

#ifdef UNICODE
	for ( p = target ; p <= maxptr ; p++ ){
#else
	for ( p = target ; p <= maxptr ; p += Chrlen(*p) ){
#endif
		if ( !tstrnicmp(p, findstr, flen) ){
			return (TCHAR *)p;
		}
	}
	return NULL;
}

// \͈͂當̉E[͂ݏoꍇ̑΍(ɕ\eEɂ炷)
void TailFix(DXDRAWSTRUCT *DxDraw, HDC hDC)
{
	POINT pos;

	if ( X_ffix == 0 ) return;
	DxGetCurrentPositionEx(DxDraw, hDC, &pos);
	pos.x += X_ffix;
	DxMoveToEx(DxDraw, hDC, pos.x, pos.y);
}

// nCCg@\teLXg\
void TextOutHL(DXDRAWSTRUCT *DxDraw, HDC hDC, ExtCompStruct *ECS, const TCHAR *str, int len)
{
	WCHAR *WordText;
	size_t WordLen;

	if ( (ECS->TypeWordLen == 0) || ((KeyWordLen != 0) && FirstKeyWord) ){
		WordText = KeyWord;
		WordLen = KeyWordLen;
	}else{
		WordText = ECS->TypeWord;
		WordLen = ECS->TypeWordLen;
	}

	if ( WordLen == 0 ){
		DxTextOutRel(DxDraw, hDC, str, len);
		return;
	}
	for (;;){
		WCHAR *findptr;
//		COLORREF OldText;
		COLORREF OldBack;

		if ( WordLen > (size_t)len ){ // 񂪕\傫
			if ( len == 0 ) return;
			DxTextOutRel(DxDraw, hDC, str, len);
			return;
		}
		findptr = tstristr(str, WordText, len);
		if ( findptr == NULL ){ // Y񖳂
			DxTextOutRel(DxDraw, hDC, str, len);
			return;
		}
		if ( findptr > str ){ // O\
			size_t lennk;

			lennk = findptr - str;
			DxTextOutRel(DxDraw, hDC, str, lennk);
			str += lennk;
			len -= lennk;
			TailFix(DxDraw, hDC);
		}
//		OldText = DxSetTextColor(DxDraw, hDC, C_WindowText);
		OldBack = DxSetBkColor(DxDraw, hDC, C_keyword);
		DxTextOutRel(DxDraw, hDC, str, WordLen); // \
		DxSetBkColor(DxDraw, hDC, OldBack);
//		DxSetTextColor(DxDraw, hDC, OldText);
		str += WordLen;
		len -= WordLen;
		if ( len ) TailFix(DxDraw, hDC);
	}
}

void FillBox(HDC hDC, const RECT *box, HBRUSH hbr)
{
	HGDIOBJ hOldObj;

	hOldObj = SelectObject(hDC, hbr);
	PatBlt(hDC, box->left, box->top, box->right - box->left, box->bottom - box->top, PATCOPY);
	SelectObject(hDC, hOldObj);
}

// *tipx ----------------------------------------------------------------------
#define TIPMARGINWIDTH 2
#define TIPBORDERWIDTH 1
#define TIPTEXTLENGTH 0x400
#define TIP_DRAW_FLAGS (DT_LEFT | DT_NOPREFIX | DT_WORDBREAK | DT_EDITCONTROL | DT_EXPANDTABS)

LRESULT CALLBACK TipWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	DXDRAWSTRUCT *DxDraw;

	switch ( message ){
		case WM_CREATE:
			CreateDxDraw(&DxDraw, hWnd);
			SetWindowLongPtr(hWnd, 0, (LONG_PTR)DxDraw);
			return 0;

		case WM_DESTROY:
			DxDraw = (DXDRAWSTRUCT *)GetWindowLongPtr(hWnd, 0);
			CloseDxDraw(&DxDraw);
			return 0;

		case WM_DISPLAYCHANGE:
			InvalidateRect(hWnd, NULL, TRUE);
			// WM_SIZE 
		case WM_SIZE:
			DxDraw = (DXDRAWSTRUCT *)GetWindowLongPtr(hWnd, 0);
			ChangeSizeDxDraw(DxDraw, C_tip[1]);
			return DefWindowProc(hWnd, message, wParam, lParam);

		case WM_KEYDOWN:
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case WM_PAINT: {
			TCHAR textbuf[TIPTEXTLENGTH], *textptr = textbuf;
			int textlength;
			RECT box;
			HBRUSH hBackBrush;
			PAINTSTRUCT ps;

			textlength = GetWindowTextLength(hWnd) + 1;
			if ( textlength <= 1 ){
				BeginPaint(hWnd, &ps);
				EndPaint(hWnd, &ps);
				return 0;
			}
			if ( textlength >= TIPTEXTLENGTH ){
				textptr = HeapAlloc(GetProcessHeap(), 0, textlength * sizeof(WCHAR));
				if ( textptr == NULL ){
					textptr = textbuf;
					textlength = TIPTEXTLENGTH - 1;
				}
			}
			GetWindowText(hWnd, textptr, textlength);

			DxDraw = (DXDRAWSTRUCT *)GetWindowLongPtr(hWnd, 0);
			GetClientRect(hWnd, &box);
			box.left += TIPMARGINWIDTH;
			box.top += TIPMARGINWIDTH;

			if ( DxDraw == NULL ) BeginPaint(hWnd, &ps);
			if ( BeginDxDraw(DxDraw, &ps) == DXSTART_NODRAW ) return 0;
			IfDXmode(ps.hdc)
			{
				DxSetTextColor(DxDraw, ps.hdc, C_tip[0]);
				DxSetBkColor(DxDraw, ps.hdc, C_tip[1]);
				DxMoveToEx(DxDraw, ps.hdc, box.left, box.top);
				DxDrawText(DxDraw, ps.hdc, textptr, -1, &box, DT_NOCLIP | TIP_DRAW_FLAGS);
				EndDxDraw(DxDraw);
			} else{
				HGDIOBJ hOldFont;

				hOldFont = SelectObject(ps.hdc, /*cinfo->hBoxFont*/ NULL);
				hBackBrush = CreateSolidBrush(C_tip[1]);
				FillBox(ps.hdc, &ps.rcPaint, hBackBrush);
				DeleteObject(hBackBrush);

				SetTextColor(ps.hdc, C_tip[0]);
				SetBkColor(ps.hdc, C_tip[1]);
				DrawText(ps.hdc, textptr, -1, &box, DT_NOCLIP | TIP_DRAW_FLAGS);
				SelectObject(ps.hdc, hOldFont);
				EndPaint(hWnd, &ps);
			}
			if ( textptr != textbuf ) HeapFree(GetProcessHeap(), 0, textptr);
			return 0;
		}
/*
		default:
			if ( message == WM_PPXCOMMAND ){
				return WmTipPPXCOMMAND(hWnd, wParam, lParam);
			}
			break;
*/
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}


int TipX(PPXAPPINFOW *ppxa, PPXMCOMMANDSTRUCT *command)
{
	const WCHAR *text;
	UINT codepage = VTYPE_UNICODE;
	WNDCLASS wndClass;
	DWORD StyleEx = WS_EX_TOOLWINDOW;
	DWORD Style = WS_POPUP | WS_BORDER | WS_CLIPCHILDREN;
	HWND hTipWnd;
	POINT pos = {100, 100};

	if ( WM_PPXCOMMAND == 0 ) InitAPI(ppxa);
	if ( command->paramcount < 1 ){
		text = L"sample text";
	}else{
		text = command->param;
	}

	wndClass.style = CS_DBLCLKS;
	wndClass.lpfnWndProc = TipWndProc;
	wndClass.cbClsExtra = 0;
	wndClass.cbWndExtra = sizeof(LONG_PTR);
	wndClass.hInstance = hInst;
	wndClass.hIcon = NULL;
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hbrBackground = NULL;
	wndClass.lpszMenuName = NULL;
	wndClass.lpszClassName = FileTipClass;
	RegisterClass(&wndClass);

	if ( C_tip[0] == C_AUTO ){
		DGetCustData(T("C_tip"), &C_tip, sizeof(C_tip));
		if ( C_tip[0] == C_AUTO ) C_tip[0] = (X_uxt[0] >= UXT_MINPRESET) ? C_DialogText : GetSysColor(COLOR_INFOTEXT);
		if ( C_tip[1] == C_AUTO ) C_tip[1] = (X_uxt[0] >= UXT_MINPRESET) ? C_DialogBack : GetSysColor(COLOR_INFOBK);
	}

	PPxInfoFunc(ppxa, PPXCMDID_POPUPPOS, &pos);

	setflag(Style, WS_THICKFRAME);
	hTipWnd = CreateWindowEx(StyleEx, FileTipClass, text,
			Style, pos.x, pos.y, 100, 100, ppxa->hWnd, NULL, hInst, ppxa);
	ShowWindow(hTipWnd, SW_SHOW);

	return PPXMRESULT_DONE;
}

// *SetListKeyword ------------------------------------------------------------
int SetListKeyword(PPXAPPINFOW *ppxa, PPXMCOMMANDSTRUCT *command)
{
	if ( command->paramcount < 1 ){
		KeyWord[0] = '\0';
		KeyWordLen = 0;
	}else{
		wcscpy(KeyWord, command->param);
		KeyWordLen = wcslen(KeyWord);
		if ( command->paramcount == 2 ){
			FirstKeyWord = TRUE;
		}else{
			FirstKeyWord = FALSE;
		}
	}
	return PPXMRESULT_DONE;
}

// lisbox g ----------------------------------------------------------------
void SetItemHeight(ExtCompStruct *ECS, HFONT hFont)
{
	HDC hDC;
	HGDIOBJ hOldFont C4701CHECK;	//ꎞۑp
	TEXTMETRIC tm;

	hDC = GetWindowDC(ECS->ListWnd);
	if ( hFont ) hOldFont = SelectObject(hDC, hFont);
	GetTextMetrics(hDC, &tm);
	if ( hFont ) SelectObject(hDC, hOldFont); // C4701ok
	ReleaseDC(ECS->ListWnd, hDC);

	ECS->hBoxFont = hFont;
//	ECS->fontX = tm.tmAveCharWidth;
	ECS->fontY = tm.tmHeight;
	ECS->ItemHeight = ECS->fontY + ECS->ItemLineSpace;
	ECS->ItemTopMargin = (ECS->ItemLineSpace + 1) / 2;

//	if ( ECS->ItemHeight != 0 ){
		SendMessage(ECS->ListWnd, LB_SETITEMHEIGHT, 0, ECS->ItemHeight);
//	}
	if ( UseDirectWrite ) SetFontDxDraw(ECS->DxDraw, hFont, 0);
}

void DrawItem(ExtCompStruct *ECS, DXDRAWSTRUCT *DxDraw, HDC hDC, RECT box, TCHAR *text, int textlength, int current, int drawmode)
{
	HBRUSH hB;
	COLORREF OldText, OldBack;
	COLORREF OldText2, OldBack2;
	TCHAR *memostart;
	int OldBkMode;

	if ( current ){
		OldText = DxSetTextColor(DxDraw, hDC, C_HighlightText);
		OldBack = DxSetBkColor(DxDraw, hDC, C_HighlightBack);
		if ( drawmode == DXSTART_GDI ){
			hB = CreateSolidBrush(C_HighlightBack);
			FillRect(hDC, &box, hB);
			DeleteObject(hB);
		}else{
			DxDrawBack(DxDraw, hDC, &box, C_HighlightBack | 0xff000000);
		}
	}else{
		OldText = DxSetTextColor(DxDraw, hDC, C_WindowText);
		OldBack = DxSetBkColor(DxDraw, hDC, C_WindowBack);
		if ( drawmode == DXSTART_GDI ){
			hB = CreateSolidBrush(C_WindowBack);
			FillRect(hDC, &box, hB);
			DeleteObject(hB);
		}
	}

	box.left += 2; // }[W
	box.top += ECS->ItemTopMargin;
	DxMoveToEx(DxDraw, hDC, box.left, box.top);

	if ( (text[0] == ';') && (text[1] == '<') ){
		WCHAR *comout;

		comout = wcsstr(text + 2, L">;");
		if ( comout != NULL ){
			OldBkMode = DxSetBkMode(DxDraw, hDC, OPAQUE);
			OldText2 = DxSetTextColor(DxDraw, hDC, C_CommentText);
			if ( current ){
				OldBack2 = DxSetBkColor(DxDraw, hDC, C_HighlightBack);
			}else{
				OldBack2 = DxSetBkColor(DxDraw, hDC, C_CommentBack);
			}

			TextOutHL(DxDraw, hDC, ECS, text + 2, comout - text - 2);
			TailFix(DxDraw, hDC);

			textlength -= comout - text + 2;
			text = comout + 2;

			DxSetTextColor(DxDraw, hDC, OldText2);
			DxSetBkColor(DxDraw, hDC, OldBack2);

			DxSetBkMode(DxDraw, hDC, OldBkMode);
//			DxSetTextAlign(hDC, TA_LEFT | TA_TOP);
		}
	}

	// Rgȍ~𕪗
	for ( memostart = text;; memostart++ ){
		TCHAR c;

		c = *memostart;
		if ( c == '\0' ){
			TextOutHL(DxDraw, hDC, ECS, text, textlength);
			break;
		}
		if ( (c == ' ') || (c == '\t') ){
			if ( *(memostart + 1) == ';' ){
//				DxSetTextAlign(hDC, TA_LEFT | TA_TOP | TA_UPDATECP); // CP L
				OldBkMode = DxSetBkMode(DxDraw, hDC, OPAQUE);
				TextOutHL(DxDraw, hDC, ECS, text, memostart - text);
				TailFix(DxDraw, hDC);
				OldText2 = DxSetTextColor(DxDraw, hDC, C_CommentText);
				if ( current ){
					OldBack2 = DxSetBkColor(DxDraw, hDC, C_HighlightBack);
				}else{
					OldBack2 = DxSetBkColor(DxDraw, hDC, C_CommentBack);
				}
				TextOutHL(DxDraw, hDC, ECS, memostart, textlength - (memostart - text));
				DxSetTextColor(DxDraw, hDC, OldText2);
				DxSetBkColor(DxDraw, hDC, OldBack2);
				DxSetBkMode(DxDraw, hDC, OldBkMode);
//				DxSetTextAlign(hDC, TA_LEFT | TA_TOP);
				break;
			}
		}
	}
}

void PaintList(ExtCompStruct *ECS, HWND hWnd)
{
	TCHAR textbuf[TIPTEXTLENGTH], *textptr = textbuf;
	int textmax = TIPTEXTLENGTH - 1, textlength, drawmode;
	RECT ibox, wndbox;
	HBRUSH hBackBrush;
	PAINTSTRUCT ps;
	DXDRAWSTRUCT *DxDraw;
	int index, selected;
	HGDIOBJ hOldFont C4701CHECK;	//ꎞۑp

	DxDraw = ECS->DxDraw;
	GetClientRect(hWnd, &wndbox);

	if ( DxDraw == NULL ) BeginPaint(hWnd, &ps);
	drawmode = BeginDxDraw(DxDraw, &ps);
	if ( drawmode == DXSTART_NODRAW ) return;
	if ( drawmode == DXSTART_GDI ){
		hBackBrush = CreateSolidBrush(C_WindowBack);
		hOldFont = SelectObject(ps.hdc, ECS->hBoxFont);
	}else{
		hBackBrush = NULL;
	}
	DxFillBack(DxDraw, ps.hdc, &wndbox, hBackBrush);
	if ( hBackBrush != NULL ) DeleteObject(hBackBrush);
	DxSetTextAlign(ps.hdc, TA_LEFT | TA_TOP | TA_UPDATECP);

	ibox.left = 0;
	ibox.top = 0;
	ibox.right = ps.rcPaint.right;
	index = CallWindowProc(ECS->ListProc, hWnd, LB_GETTOPINDEX, 0, 0);
	selected = CallWindowProc(ECS->ListProc, hWnd, LB_GETCURSEL, 0, 0);

	for ( ; ibox.top < wndbox.bottom; ibox.top = ibox.bottom, index++){
		ibox.bottom = ibox.top + ECS->ItemHeight + 0;

		textlength = CallWindowProc(ECS->ListProc, hWnd, LB_GETTEXTLEN, index, 0);
		if ( textlength <= 0 ) continue;
		if ( textlength >= TIPTEXTLENGTH ){
			if ( textptr != textbuf ) HeapFree(GetProcessHeap(), 0, textptr);
			textmax = textlength;
			textptr = HeapAlloc(GetProcessHeap(), 0, (textmax + 1) * sizeof(WCHAR));
			if ( textptr == NULL ){
				textptr = textbuf;
				textmax = textlength = TIPTEXTLENGTH - 1;
				continue;
			}
		}
		*textptr = '\0';
		CallWindowProc(ECS->ListProc, hWnd, LB_GETTEXT, index, (LPARAM)textptr);

		DrawItem(ECS, DxDraw, ps.hdc, ibox, textptr, textlength, (index == selected), drawmode);
	}

	if ( textptr != textbuf ) HeapFree(GetProcessHeap(), 0, textptr);
	if ( drawmode == DXSTART_GDI ){
		SelectObject(ps.hdc, hOldFont);
	}
	EndDxDraw(DxDraw);
}

LRESULT CALLBACK ExtComplistProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	ExtCompStruct *ECS;

	ECS = GetProp(hWnd, StrExtComplistProperty);
	if ( ECS == NULL ) return DefWindowProc(hWnd, message, wParam, lParam);

	switch ( message ){
		case WM_SETFONT: {
			LRESULT result = CallWindowProc(ECS->ListProc, hWnd, message, wParam, lParam);
			SetItemHeight(ECS, (HFONT)wParam);
			return result;
		}

		case WM_DESTROY: {
			WNDPROC oldproc;

			RemoveProp(hWnd, StrExtComplistProperty);
			CloseDxDraw(&ECS->DxDraw);
			oldproc = ECS->ListProc;
			HeapFree(GetProcessHeap(), 0, ECS);
			return CallWindowProc(oldproc, hWnd, message, wParam, lParam);
		}

		case WM_ERASEBKGND:
			return 1;

		case WM_DISPLAYCHANGE:
			InvalidateRect(hWnd, NULL, TRUE);
			// WM_SIZE 
		case WM_SIZE:
			if ( UseDirectWrite ) ChangeSizeDxDraw(ECS->DxDraw, C_WindowBack);
			break;

		case WM_PAINT:
			if ( !UseDirectWrite ) break;
			PaintList(ECS, hWnd);
			return 0;

		case LB_SETCURSEL:
			if ( !UseDirectWrite ){
				break;
			}else{
				LRESULT result;

				CallWindowProc(ECS->ListProc, hWnd, WM_SETREDRAW, 0, 0);
				result = CallWindowProc(ECS->ListProc, hWnd, message, wParam, lParam);
				CallWindowProc(ECS->ListProc, hWnd, WM_SETREDRAW, 1, 0);
				RedrawWindow(hWnd, NULL, NULL, RDW_FRAME | RDW_INVALIDATE);
				return result;
			}

		default:
			if ( message == WM_PPXCOMMAND ){
				if ( LOWORD(wParam) == KE_editword ){
					size_t len;

					len = HIWORD(wParam);
					if ( len >= TSIZEOFSTR(ECS->TypeWord) ){
						len = TSIZEOFSTR(ECS->TypeWord);
					}
					memcpy(ECS->TypeWord, (char *)lParam, TSTROFF(len));
					ECS->TypeWord[len] = '\0';
					ECS->TypeWordLen = len;
				}
				return 0;
			}
			break;

	}
	return CallWindowProc(ECS->ListProc, hWnd, message, wParam, lParam);
}

void CompDraw(ExtCompStruct *ECS, DRAWITEMSTRUCT *lpdis)
{
	TCHAR buf[CMDLINESIZE], *bufp = buf, *mem = NULL;
	int len;

	if ( (int)lpdis->itemID >= 0 ){
		// \`
		len = SendMessage(lpdis->hwndItem, LB_GETTEXTLEN, lpdis->itemID, 0);
		if ( len >= (CMDLINESIZE - 1) ){
			bufp = mem = HeapAlloc(GetProcessHeap(), 0, len * sizeof(WCHAR));
		}
		SendMessage(lpdis->hwndItem, LB_GETTEXT, lpdis->itemID, (LPARAM)bufp);
		SetTextAlign(lpdis->hDC, TA_LEFT | TA_TOP | TA_UPDATECP);
		SetBkMode(lpdis->hDC, OPAQUE);

		DrawItem(ECS, NULL, lpdis->hDC, lpdis->rcItem, bufp, len, (lpdis->itemState & ODS_SELECTED), DXSTART_GDI);

		if ( mem != NULL ) HeapFree(GetProcessHeap(), 0, mem);
	}
#if 0
	// tH[JXg`
	if ( lpdis->itemState & ODS_FOCUS ){
		// C_EdgeLine
		FrameRect(lpdis->hDC, &lpdis->rcItem, GetStockObject(DKGRAY_BRUSH));
	}
#endif
}

LRESULT CALLBACK CompMsgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	ExtCompStruct *ECS;

	ECS = (ExtCompStruct *)GetWindowLongPtr(hWnd, GWLP_USERDATA);
	if ( ECS == NULL ){
		if ( message == WM_CREATE ){
			SetWindowLongPtr(hWnd, GWLP_USERDATA,
					(LONG_PTR)(((CREATESTRUCT *)lParam)->lpCreateParams));
			return 0;
		}
		// WM_CREATE ̑O WM_GETMINMAXINFO, WM_NCCREATE, WM_NCDESTROY,
		// WM_NCCALCSIZE 
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	switch ( message ){
		case WM_DRAWITEM:
			if ( UseDirectWrite ){
				InvalidateRect(ECS->ListWnd, NULL, FALSE);
			}else{
				CompDraw(ECS, (DRAWITEMSTRUCT *)lParam);
			}
			return 0;

		case WM_COMMAND:
			return SendMessage(ECS->ParentWnd, WM_COMMAND, wParam, lParam);
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

int InitExtComplist(PPXAPPINFOW *ppxa, PPXMEXTLISTBOX *els)
{
	ExtCompStruct *ECS;
	WCHAR buf[CMDLINESIZE];
	const WCHAR *bufp;

	if ( WM_PPXCOMMAND == 0 ) InitAPI(ppxa);

	buf[0] = '\0';
	DGetCustTable(L"_others", L"ListDraw", &buf, sizeof(buf));
	bufp = buf;
	if ( *bufp != '\0' ) UseDirectWrite = DGetNumber(&bufp);

	if ( compinit == 0 ){
		if ( CompMsgAtom == 0 ){
			WNDCLASS wcClass;

			wcClass.style			= 0;
			wcClass.lpfnWndProc		= CompMsgProc;
			wcClass.cbClsExtra		= 0;
			wcClass.cbWndExtra		= 0;
			wcClass.hInstance		= hInst;
			wcClass.hIcon			= NULL;
			wcClass.hCursor			= NULL;
			wcClass.hbrBackground	= NULL;
			wcClass.lpszMenuName	= NULL;
			wcClass.lpszClassName	= CompMsgClass;
											// NXo^
			CompMsgAtom = RegisterClass(&wcClass);
		}

		DGetCustData(L"C_win", &wincolors, sizeof(wincolors));

		DEFWINCOLOR(C_WindowBack, COLOR_WINDOW);
		DEFWINCOLOR(C_WindowText, COLOR_WINDOWTEXT);
		DEFWINCOLOR(C_HighlightText, COLOR_HIGHLIGHTTEXT);
		DEFWINCOLOR(C_HighlightBack, COLOR_HIGHLIGHT);
		DEFWINCOLOR(C_EdgeLine, COLOR_LIGHT_EDGE_LINE);

		C_CommentBack = C_WindowBack;
		C_CommentText = C_COMMENT_TEXT;
		buf[0] = '\0';
		DGetCustTable(L"_others", L"ListCommentColor", &buf, sizeof(buf));
		bufp = buf;
		if ( *bufp != '\0' ){
			C_CommentText = DGetColor(&bufp, TRUE);
			if ( DSkipSpace(&bufp) == ',' ){
				bufp++;
				C_CommentBack = DGetColor(&bufp, TRUE);

				if ( DSkipSpace(&bufp) == ',' ){
					bufp++;
					C_keyword = DGetColor(&bufp, TRUE);
				}
			}
		}

		// *setcust _others:ListColors=h123456,hffccaa,h346512,haaffcc
		buf[0] = '\0';
		DGetCustTable(L"_others", L"ListColors", &buf, sizeof(buf));
		bufp = buf;
		if ( *bufp != '\0' ){
			C_WindowText = DGetColor(&bufp, TRUE);
			if ( DSkipSpace(&bufp) == ',' ) bufp++;
			C_WindowBack = DGetColor(&bufp, TRUE);
			if ( DSkipSpace(&bufp) == ',' ) bufp++;
			C_HighlightText = DGetColor(&bufp, TRUE);
			if ( DSkipSpace(&bufp) == ',' ) bufp++;
			C_HighlightBack = DGetColor(&bufp, TRUE);
		}

		DGetCustData(L"X_ffix", &X_ffix, sizeof(X_ffix));
		buf[0] = '\0';
		DGetCustTable(L"_others", L"ListFfix", &buf, sizeof(buf));
		bufp = buf;
		if ( *bufp != '\0' ){
			int pix;
			pix = DGetNumber(&bufp);
			if ( pix > 0 ) X_ffix = pix;
		}
		compinit = 1;
	}

	ECS = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(ExtCompStruct));

	ECS->ParentWnd = els->hParentWnd;
	ECS->MsgWnd = CreateWindowEx(0, (const TCHAR *)CompMsgAtom, NilStr, 0,
			0, 0, 1, 1,
			ECS->ParentWnd, NULL, hInst, ECS);
	ECS->ListID = (UINT)(ULONG_PTR)els->hMenu;

	ECS->ListWnd = els->hListWnd = CreateWindowEx(els->ExStyle, L"LISTBOX",
			NilStr, els->Style | LBS_HASSTRINGS | LBS_OWNERDRAWFIXED,
			els->x, els->y, els->width, els->height,
			ECS->MsgWnd, els->hMenu, els->hInst, els->lParam);
	if ( UseDirectWrite ) CreateDxDraw(&ECS->DxDraw, ECS->ListWnd);

	SetProp(els->hListWnd, StrExtComplistProperty, (HANDLE)ECS);
	ECS->ListProc = (WNDPROC)SetWindowLongPtr(els->hListWnd, GWLP_WNDPROC, (LONG_PTR)ExtComplistProc);

	buf[0] = '\0';
	DGetCustTable(L"_others", L"ListItemSpace", &buf, sizeof(buf));
	bufp = buf;
	if ( *bufp != '\0' ) ECS->ItemLineSpace = DGetNumber(&bufp);

	{
		HFONT ListFont = (HFONT)SendMessage(els->hParentWnd, WM_GETFONT, 0, 0);

		SendMessage(ECS->ListWnd, WM_SETFONT, (WPARAM)ListFont, 0);
		SetItemHeight(ECS, ListFont);
	}
	ECS->type = els->type;
	return PPXMRESULT_DONE;
}

UTCHAR GetCommandParameter(LPCTSTR *commandline, TCHAR *param, size_t paramlen)
{
	const TCHAR *src;
	TCHAR *dest, *destmax;
	UTCHAR firstcode, code;

	firstcode = DSkipSpace(commandline);
	if ( (firstcode == '\0') || (firstcode == ',') ){ // p[^
		*param = '\0';
		return firstcode;
	}
	dest = param;
	destmax = dest + paramlen - 1;
	if ( firstcode == '\"' ){
		DGetQuotedParameter(commandline, param, destmax);
		return *param;
	}
	src = *commandline + 1;
	code = firstcode;
	for ( ;; ){
		if ( dest < destmax ) *dest++ = code;
		code = *src;
		if ( (code == ',') || // (code == ' ') ||
			 ((code < ' ') && ((code == '\0') || (code == '\t') ||
							   (code == '\r') || (code == '\n'))) ){
			break;
		}
		src++;
	}
	while ( (dest > param) && (*(dest - 1) == ' ') ) dest--; // choptail
	*dest = '\0';
	*commandline = src;
	return firstcode;
}
